import java.util.Date;
import java.io.*;
import java.text.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class GetDrive extends HttpServlet {

	ManageDrive manageDrive = new ManageDrive();
	String returnMsg="";
	String log="";
    
    /*public void init() {
    }*/
    
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        
        response.setContentType("text/plain");
	    PrintWriter out =response.getWriter();
	    String readData = request.getParameter("str");
		 
		System.out.println("REQUEST "+readData+" ..@"+new Date());
	     
	    readData = readData.replaceAll("\\|","+");
	    readData = readData.replaceAll("\\*"," ");
		
        if(readData.startsWith("DL$")) {
	        log = "Preparing Drive List..@"+new Date();
			System.out.println(log);
	      	returnMsg = manageDrive.driveList();
	      	out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
	    }
		  
		else if(readData.startsWith("Desk$")) {
			log = "Displaying desktop files and folders..@";
			System.out.println(log);
			returnMsg = manageDrive.directoryList("desktop");
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		 
		else if(readData.startsWith("FL$")) {
			readData = readData.substring(3);
			log = "Displaying directory contents of : "+readData;
			System.out.println(log);
			returnMsg = manageDrive.directoryList(readData);
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		else if(readData.startsWith("DF$")) {
			readData = readData.substring(3);
			readData = readData.replace('*', ' ') ;
			log = "Deleting File : "+readData+" @.."+new Date();
			System.out.println(log);
			returnMsg = manageDrive.delFile(readData);
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		else if(readData.startsWith("DD$")) {
			boolean success;
			readData = readData.substring(3);
			readData = readData.replace('*', ' ') ;
			log = "Deleting Directory : "+readData;
			System.out.println(log);
			
			success = manageDrive.delDir(new File(readData));
			if (success) {
				// Deletion successful
				log = "Directory Successfully Deleted ..@"+new Date();
				System.out.println(log);
			} 
			else {
				log = "Directory deletion error ..@"+new Date();
				System.out.println(log);
			}
			out.println(log);
		}
		 else if(readData.startsWith("RF$")) {
			readData = readData.substring(3);
			System.out.println(readData);
			String[] paths = readData.split("\\$\\$");
			String oldName = paths[0];
			oldName = oldName.replace('*', ' ') ;
			System.out.println("oldName : " + oldName); 
			
			String newName = paths[1];
			newName = newName.replace('*', ' ') ;
			System.out.println("newName: "+ newName);
			
			log = "Renaming File/Directory "+oldName+" to "+newName;
			System.out.println(log);
			returnMsg = manageDrive.renameFileDir(oldName,newName);
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log+"\n");
		}
		else if(readData.startsWith("ND$")) {
			readData = readData.substring(3);
			readData = readData.replaceAll("\\*"," ");
			log = "Making new directory path = "+readData+" ..@";
			returnMsg = manageDrive.newDir(readData);
			
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		 
		else if(readData.startsWith("COPY$")) {
			readData = readData.substring(5);
			//Splitting  source  and  destination
			String[] content = readData.split("\\$\\$");
			
			System.out.println("Copy files are: "+ content[0] +"  and  "+content[1]);
			//source Path
			content[0] = content[0].replaceAll("\\*"," ");
			System.out.println(content[0]);
			//Destination Path
			content[1] = content[1].replaceAll("\\*"," ");
			System.out.println(content[1]);
			
			log = "Preparing to COPY "+content[0]+" to "+content[1] ; 
			returnMsg = manageDrive.copyFileDir(new File(content[0]),new File(content[1]));
			
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
			
		}
		else if(readData.startsWith("CUT$")) {
			readData = readData.substring(4);
			//Splitting  source  and  destination
			String[] content = readData.split("\\$\\$");
			
			//source Path
			content[0] = content[0].replaceAll("\\*"," ");
			
			//System.out.println(content[0]);
			
			//Destination Path
			content[1] = content[1].replaceAll("\\*"," ");
			//System.out.println(content[1]);
			
			log = "Preparing to COPY "+content[0]+" to "+content[1] ; 
			returnMsg = manageDrive.cutFileDir(content[0],content[1]);
			
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		else if(readData.startsWith("SZ$")) {
			long size = 0;
			readData = readData.substring(3);
			readData = readData.replaceAll("\\*", " " ) ;
			log = "Generating the size of "+readData+" ..@";
			System.out.println(log);
			size = manageDrive.getFileDirSize(new File(readData));
			log = "Size is "+size/1000+"KB";
			System.out.println(log);
			returnMsg = log ;
			out.println(returnMsg);
			log = "Response Successfully sent!!";
			System.out.println(log);
		}
		  
		out.flush();
		out.close();
    }
    
    /*public void doPost(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, 
            IOException {
        
        doGet(request,response);
    }*/
}